package com.hai.dao;

import com.hai.entity.HighDiscount;
import com.hai.entity.HighDiscountExample.Criteria;
import com.hai.entity.HighDiscountExample.Criterion;
import com.hai.entity.HighDiscountExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighDiscountSqlProvider {

    public String countByExample(HighDiscountExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_discount");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighDiscountExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_discount");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighDiscount record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_discount");
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountKey() != null) {
            sql.VALUES("discount_key", "#{discountKey,jdbcType=VARCHAR}");
        }
        
        if (record.getUsingRange() != null) {
            sql.VALUES("using_range", "#{usingRange,jdbcType=INTEGER}");
        }
        
        if (record.getUseScope() != null) {
            sql.VALUES("use_scope", "#{useScope,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountName() != null) {
            sql.VALUES("discount_name", "#{discountName,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountImg() != null) {
            sql.VALUES("discount_img", "#{discountImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountCarouselImg() != null) {
            sql.VALUES("discount_carousel_img", "#{discountCarouselImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountType() != null) {
            sql.VALUES("discount_type", "#{discountType,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountCondition() != null) {
            sql.VALUES("discount_condition", "#{discountCondition,jdbcType=DECIMAL}");
        }
        
        if (record.getDiscountPrice() != null) {
            sql.VALUES("discount_price", "#{discountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getReceiveNumber() != null) {
            sql.VALUES("receive_number", "#{receiveNumber,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveDay() != null) {
            sql.VALUES("effective_day", "#{effectiveDay,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.VALUES("sales_end_time", "#{salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.VALUES("operator_id", "#{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.VALUES("operator_name", "#{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighDiscountExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("company_id");
        sql.SELECT("discount_key");
        sql.SELECT("using_range");
        sql.SELECT("use_scope");
        sql.SELECT("discount_name");
        sql.SELECT("discount_img");
        sql.SELECT("discount_carousel_img");
        sql.SELECT("discount_type");
        sql.SELECT("discount_condition");
        sql.SELECT("discount_price");
        sql.SELECT("receive_number");
        sql.SELECT("effective_day");
        sql.SELECT("sales_end_time");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("operator_id");
        sql.SELECT("operator_name");
        sql.SELECT("`status`");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_discount");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighDiscount record = (HighDiscount) parameter.get("record");
        HighDiscountExample example = (HighDiscountExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_discount");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountKey() != null) {
            sql.SET("discount_key = #{record.discountKey,jdbcType=VARCHAR}");
        }
        
        if (record.getUsingRange() != null) {
            sql.SET("using_range = #{record.usingRange,jdbcType=INTEGER}");
        }
        
        if (record.getUseScope() != null) {
            sql.SET("use_scope = #{record.useScope,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountName() != null) {
            sql.SET("discount_name = #{record.discountName,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountImg() != null) {
            sql.SET("discount_img = #{record.discountImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountCarouselImg() != null) {
            sql.SET("discount_carousel_img = #{record.discountCarouselImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountType() != null) {
            sql.SET("discount_type = #{record.discountType,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountCondition() != null) {
            sql.SET("discount_condition = #{record.discountCondition,jdbcType=DECIMAL}");
        }
        
        if (record.getDiscountPrice() != null) {
            sql.SET("discount_price = #{record.discountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getReceiveNumber() != null) {
            sql.SET("receive_number = #{record.receiveNumber,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveDay() != null) {
            sql.SET("effective_day = #{record.effectiveDay,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.SET("sales_end_time = #{record.salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_discount");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("discount_key = #{record.discountKey,jdbcType=VARCHAR}");
        sql.SET("using_range = #{record.usingRange,jdbcType=INTEGER}");
        sql.SET("use_scope = #{record.useScope,jdbcType=INTEGER}");
        sql.SET("discount_name = #{record.discountName,jdbcType=VARCHAR}");
        sql.SET("discount_img = #{record.discountImg,jdbcType=VARCHAR}");
        sql.SET("discount_carousel_img = #{record.discountCarouselImg,jdbcType=VARCHAR}");
        sql.SET("discount_type = #{record.discountType,jdbcType=INTEGER}");
        sql.SET("discount_condition = #{record.discountCondition,jdbcType=DECIMAL}");
        sql.SET("discount_price = #{record.discountPrice,jdbcType=DECIMAL}");
        sql.SET("receive_number = #{record.receiveNumber,jdbcType=INTEGER}");
        sql.SET("effective_day = #{record.effectiveDay,jdbcType=INTEGER}");
        sql.SET("sales_end_time = #{record.salesEndTime,jdbcType=TIMESTAMP}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighDiscountExample example = (HighDiscountExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighDiscount record) {
        SQL sql = new SQL();
        sql.UPDATE("high_discount");
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountKey() != null) {
            sql.SET("discount_key = #{discountKey,jdbcType=VARCHAR}");
        }
        
        if (record.getUsingRange() != null) {
            sql.SET("using_range = #{usingRange,jdbcType=INTEGER}");
        }
        
        if (record.getUseScope() != null) {
            sql.SET("use_scope = #{useScope,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountName() != null) {
            sql.SET("discount_name = #{discountName,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountImg() != null) {
            sql.SET("discount_img = #{discountImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountCarouselImg() != null) {
            sql.SET("discount_carousel_img = #{discountCarouselImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountType() != null) {
            sql.SET("discount_type = #{discountType,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountCondition() != null) {
            sql.SET("discount_condition = #{discountCondition,jdbcType=DECIMAL}");
        }
        
        if (record.getDiscountPrice() != null) {
            sql.SET("discount_price = #{discountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getReceiveNumber() != null) {
            sql.SET("receive_number = #{receiveNumber,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveDay() != null) {
            sql.SET("effective_day = #{effectiveDay,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.SET("sales_end_time = #{salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighDiscountExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}